FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_Menu_ Class Reference

Base class of all widgets that have a menu in FLTK. More...

`#include <Fl_Menu_.H>`

Inheritance diagram for Fl_Menu_:

## Public Member Functions
int | add (const char *)
| This is a Forms (and SGI GL library) compatible add function, it adds many menu items, with '|' separating the menu items, and tab separating the menu item names from an optional shortcut string.
int | add (const char *, int shortcut, Fl_Callback *, void *=0, int=0)
| Adds a new menu item.
int | add (const char *a, const char *b, Fl_Callback *c, void *d=0, int e=0)
| See int Fl_Menu_::add(const char* label, int shortcut, Fl_Callback*, void *user_data=0, int flags=0).
void | clear ()
| Same as menu(NULL), set the array pointer to null, indicating a zero-length menu.
int | clear_submenu (int index)
| Clears the specified submenu pointed to by `index` of all menu items.
void | copy (const Fl_Menu_Item *m, void *user_data=0)
| Sets the menu array pointer with a copy of m that will be automatically deleted.
Fl_Boxtype | down_box () const
| This box type is used to surround the currently-selected items in the menus.
void | down_box (Fl_Boxtype b)
| Sets the box type used to surround the currently-selected items in the menus.
Fl_Color | down_color () const
| For back compatibility, same as selection_color().
void | down_color (unsigned c)
| For back compatibility, same as selection_color().
int | find_index (const char *name) const
| Find the menu item index for a given menu `pathname`, such as "Edit/Copy".
int | find_index (const Fl_Menu_Item *item) const
| Find the index into the menu array for a given `item`.
int | find_index (Fl_Callback *cb) const
| Find the index into the menu array for a given callback `cb`.
const Fl_Menu_Item * | find_item (const char *name)
| Find the menu item for a given menu `pathname`, such as "Edit/Copy".
const Fl_Menu_Item * | find_item (Fl_Callback *)
| Find the menu item for the given callback `cb`.
const Fl_Menu_Item * | find_item_with_argument (long)
| Find the menu item for the given user argument `v`.
const Fl_Menu_Item * | find_item_with_user_data (void *)
| Find the menu item for the given user data `v`.
| Fl_Menu_ (int, int, int, int, const char *=0)
| Creates a new Fl_Menu_ widget using the given position, size, and label string.
void | global ()
| Make the shortcuts for this menu work no matter what window has the focus when you type it.
int | insert (int index, const char *, int shortcut, Fl_Callback *, void *=0, int=0)
| Inserts a new menu item at the specified `index` position.
int | insert (int index, const char *a, const char *b, Fl_Callback *c, void *d=0, int e=0)
| See int Fl_Menu_::insert(const char* label, int shortcut, Fl_Callback*, void *user_data=0, int flags=0).
int | item_pathname (char *name, int namelen, const Fl_Menu_Item *finditem=0) const
| Get the menu 'pathname' for the specified menuitem.
const Fl_Menu_Item * | menu () const
| Returns a pointer to the array of Fl_Menu_Items.
void | menu (const Fl_Menu_Item *m)
| Sets the menu array pointer directly.
Fl_Boxtype | menu_box () const
| Get the box type for the menu popup windows.
void | menu_box (Fl_Boxtype b)
| Set the box type for the menu popup windows.
const Fl_Menu_Item * | menu_end ()
| Finishes menu modifications and returns menu().
int | mode (int i) const
| Get the flags of item i.
void | mode (int i, int fl)
| Set the flags of item i.
const Fl_Menu_Item * | mvalue () const
| Return a pointer to the last menu item that was picked.
const Fl_Menu_Item * | picked (const Fl_Menu_Item *)
| When user picks a menu item, call this.
const Fl_Menu_Item * | prev_mvalue () const
| Return a pointer to the menu item that was picked before the current one was picked.
void | remove (int)
| Deletes item `i` from the menu.
void | replace (int, const char *)
| Changes the text of item `i`.
void | setonly (Fl_Menu_Item *item)
| Turns the radio item "on" for the menu item and turns "off" adjacent radio items of the same group.
void | shortcut (int i, int s)
| Change the shortcut of item `i` to `s`.
int | size () const
| This returns the number of Fl_Menu_Item structures that make up the menu, correctly counting submenus.
void | size (int W, int H)
const Fl_Menu_Item * | test_shortcut ()
| Returns the menu item with the entered shortcut (key value).
const char * | text () const
| Returns the title of the last item chosen.
const char * | text (int i) const
| Returns the title of item i.
Fl_Color | textcolor () const
| Get the current color of menu item labels.
void | textcolor (Fl_Color c)
| Sets the current color of menu item labels.
Fl_Font | textfont () const
| Gets the current font of menu item labels.
void | textfont (Fl_Font c)
| Sets the current font of menu item labels.
Fl_Fontsize | textsize () const
| Gets the font size of menu item labels.
void | textsize (Fl_Fontsize c)
| Sets the font size of menu item labels.
int | value () const
| Return the index into the menu() of the last item chosen by the user.
int | value (const Fl_Menu_Item *)
| Set the value of a menu to the menu item `m`.
int | value (int i)
| Set the value of the menu to index `i`.
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget.
unsigned int | active () const
| Returns whether the widget is active.
int | active_r () const
| Returns whether the widget and all of its parents are active.
Fl_Align | align () const
| Gets the label alignment.
void | align (Fl_Align alignment)
| Sets the label alignment.
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function.
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window.
virtual class Fl_Gl_Window const * | as_gl_window () const
virtual Fl_Group * | as_group ()
| Returns an Fl_Group pointer if this widget is an Fl_Group.
virtual Fl_Group const * | as_group () const
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window.
virtual Fl_Window const * | as_window () const
void | bind_deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
void | bind_deimage (int f)
| Bind the inactive image to the widget, so the widget will delete the image when it is no longer needed.
void | bind_image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
void | bind_image (int f)
| Bind the image to the widget, so the widget will delete the image when it is no longer needed.
Fl_Boxtype | box () const
| Gets the box type of the widget.
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget.
Fl_Callback_p | callback () const
| Gets the current callback function for the widget.
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback *cb, Fl_Callback_User_Data *p, bool auto_free)
| Sets the current callback function and managed user data for the widget.
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function and data for the widget.
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget.
unsigned int | changed () const
| Checks if the widget value changed since the last callback.
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus.
void | clear_changed ()
| Marks the value of the widget as unchanged.
void | clear_damage (uchar c=0)
| Clears or sets the damage flags.
void | clear_output ()
| Sets a widget to accept input.
void | clear_visible ()
| Hides the widget.
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget.
Fl_Color | color () const
| Gets the background color of the widget.
void | color (Fl_Color bg)
| Sets the background color of the widget.
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget.
Fl_Color | color2 () const
| For back compatibility only.
void | color2 (unsigned a)
| For back compatibility only.
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget.
void | copy_label (const char *new_label)
| Sets the current label.
void | copy_tooltip (const char *text)
| Sets the current tooltip text.
uchar | damage () const
| Returns non-zero if draw() needs to be called.
void | damage (uchar c)
| Sets the damage bits for the widget.
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget.
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget.
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label when in the inactive state.
const Fl_Image * | deimage () const
| Gets the image that is used as part of the widget label when in the inactive state.
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label when in the inactive state.
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
int | deimage_bound () const
| Returns whether the inactive image is managed by the widget.
void | do_callback (Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with default arguments.
void | do_callback (Fl_Widget *widget, long arg, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | do_callback (Fl_Widget *widget, void *arg=0, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
virtual void | draw ()=0
| Draws the widget.
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment.
int | h () const
| Gets the widget height.
virtual int | handle (int event)
| Handles the specified event.
virtual void | hide ()
| Makes a widget invisible.
int | horizontal_label_margin ()
| Get the spacing between the label and the horizontal edge of the widget.
void | horizontal_label_margin (int px)
| Set the spacing between the label and the horizontal edge of the widget.
Fl_Image * | image ()
| Gets the image that is used as part of the widget label when in the active state.
const Fl_Image * | image () const
| Gets the image that is used as part of the widget label when in the active state.
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label when in the active state.
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
int | image_bound () const
| Returns whether the image is managed by the widget.
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`.
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label().
const char * | label () const
| Gets the current label text.
void | label (const char *text)
| Sets the current label pointer.
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call.
int | label_image_spacing ()
| Return the gap size between the label and the image.
void | label_image_spacing (int gap)
| Set the gap between the label and the image in pixels.
Fl_Color | labelcolor () const
| Gets the label color.
void | labelcolor (Fl_Color c)
| Sets the label color.
Fl_Font | labelfont () const
| Gets the font to use.
void | labelfont (Fl_Font f)
| Sets the font to use.
Fl_Fontsize | labelsize () const
| Gets the font size in pixels.
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels.
Fl_Labeltype | labeltype () const
| Gets the label type.
void | labeltype (Fl_Labeltype a)
| Sets the label type.
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size.
bool | needs_keyboard () const
| Returns whether this widget needs a keyboard.
void | needs_keyboard (bool needs)
| Sets whether this widget needs a keyboard.
unsigned int | output () const
| Returns if a widget is used for output only.
Fl_Group * | parent () const
| Returns a pointer to the parent widget.
void | parent (Fl_Group *p)
| Internal use only - "for hacks only".
void | position (int X, int Y)
| Repositions the window or widget.
void | redraw ()
| Schedules the drawing of the widget.
void | redraw_label ()
| Schedules the drawing of the label.
virtual void | resize (int x, int y, int w, int h)
| Changes the size or position of the widget.
Fl_Color | selection_color () const
| Gets the selection color.
void | selection_color (Fl_Color a)
| Sets the selection color.
void | set_active ()
| Marks the widget as active without sending events or changing focus.
void | set_changed ()
| Marks the value of the widget as changed.
void | set_output ()
| Sets a widget to output only.
void | set_visible ()
| Makes the widget visible.
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget.
int | shortcut_label () const
| Returns whether the widget's label uses '&' to indicate shortcuts.
void | shortcut_label (int value)
| Sets whether the widget's label uses '&' to indicate shortcuts.
virtual void | show ()
| Makes a widget visible.
void | size (int W, int H)
| Changes the size of the widget.
int | take_focus ()
| Gives the widget the keyboard focus.
unsigned int | takesevents () const
| Returns if the widget is able to take events.
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut.
const char * | tooltip () const
| Gets the current tooltip text.
void | tooltip (const char *text)
| Sets the current tooltip text.
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget.
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window.
uchar | type () const
| Gets the widget type.
void | type (uchar t)
| Sets the widget type.
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget.
void | user_data (Fl_Callback_User_Data *v, bool auto_free)
| Sets the user data for this widget.
void | user_data (void *v)
| Sets the user data for this widget.
int | vertical_label_margin ()
| Get the spacing between the label and the vertical edge of the widget.
void | vertical_label_margin (int px)
| Set the spacing between the label and the vertical edge of the widget.
unsigned int | visible () const
| Returns whether a widget is visible.
unsigned int | visible_focus () const
| Checks whether this widget has a visible focus.
void | visible_focus (int v)
| Modifies keyboard focus navigation.
int | visible_r () const
| Returns whether a widget and all its parents are visible.
int | w () const
| Gets the widget width.
Fl_When | when () const
| Returns the conditions under which the callback is called.
void | when (uchar i)
| Sets the flags used to decide when a callback is called.
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy.
int | x () const
| Gets the widget position in its window.
int | y () const
| Gets the widget position in its window.
virtual | ~Fl_Widget ()
| Destroys the widget.

## Protected Member Functions
int | item_pathname_ (char *name, int namelen, const Fl_Menu_Item *finditem, const Fl_Menu_Item *menu=0) const
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus () const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int X, int Y, int W, int H) const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color bg) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position.
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box.
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size.
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only.
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only.
void | x (int v)
| Internal use only.
void | y (int v)
| Internal use only.

## Protected Attributes
uchar | alloc
uchar | down_box_
Fl_Boxtype | menu_box_
Fl_Color | textcolor_
Fl_Font | textfont_
Fl_Fontsize | textsize_

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *widget, void *data)
| The default callback for all widgets that don't set a callback.
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text.
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut.
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0 , INVISIBLE = 1<<1 , OUTPUT = 1<<2 , NOBORDER = 1<<3 , FORCE_POSITION = 1<<4 , NON_MODAL = 1<<5 , SHORTCUT_LABEL = 1<<6 , CHANGED = 1<<7 , OVERRIDE = 1<<8 , VISIBLE_FOCUS = 1<<9 , COPIED_LABEL = 1<<10 , CLIP_CHILDREN = 1<<11 , MENU_WINDOW = 1<<12 , TOOLTIP_WINDOW = 1<<13 , MODAL = 1<<14 , NO_OVERLAY = 1<<15 , GROUP_RELATIVE = 1<<16 , COPIED_TOOLTIP = 1<<17 , FULLSCREEN = 1<<18 , MAC_USE_ACCENTS_MENU = 1<<19 , NEEDS_KEYBOARD = 1<<20 , IMAGE_BOUND = 1<<21 , DEIMAGE_BOUND = 1<<22 , AUTO_DELETE_USER_DATA = 1<<23 , MAXIMIZED = 1<<24 , POPUP = 1<<25 , USERFLAG3 = 1<<29 , USERFLAG2 = 1<<30 , USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Detailed Description

Base class of all widgets that have a menu in FLTK.

Currently FLTK provides you with Fl_Menu_Button, Fl_Menu_Bar, and Fl_Choice.

The class contains a pointer to an array of structures of type Fl_Menu_Item. The array may either be supplied directly by the user program, or it may be "private": a dynamically allocated array managed by the Fl_Menu_.

When the user clicks a menu item, value() is set to that item and then:

- If the Fl_Menu_Item has a callback set, that callback is invoked with any userdata configured for it. (The Fl_Menu_ widget's callback is NOT invoked.)
- For any Fl_Menu_Items that don't have a callback set, the Fl_Menu_ widget's callback is invoked with any userdata configured for it. The callback can determine which item was picked using value(), mvalue(), item_pathname(), etc.

The line spacing between menu items can be controlled with the global setting Fl::menu_linespacing().

See also
  Fl_Widget::shortcut_label(int)

## Constructor & Destructor Documentation

## ◆ Fl_Menu_()

Fl_Menu_::Fl_Menu_ | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | l = 0 )

Creates a new Fl_Menu_ widget using the given position, size, and label string.

menu() is initialized to null.

## Member Function Documentation

## ◆ add() [1/2]

int Fl_Menu_::add | ( | const char * | str | ) |

This is a Forms (and SGI GL library) compatible add function, it adds many menu items, with '|' separating the menu items, and tab separating the menu item names from an optional shortcut string.

The passed string is split at any '|' characters and then add(s,0,0,0,0) is done with each section. This is often useful if you are just using the value, and is compatible with Forms and other GL programs. The section strings use the same special characters as described for the long version of add().

No items must be added to a menu during a callback to the same menu.

Parameters

  str | string containing multiple menu labels as described above

Returns
  the index into the menu() array, where the entry was added

## ◆ add() [2/2]

int Fl_Menu_::add | ( | const char * | label,
|  | int | shortcut,
|  | Fl_Callback * | callback,
|  | void * | userdata = 0,
|  | int | flags = 0 )

Adds a new menu item.

Parameters

  [in] | label | The text label for the menu item.
  [in] | shortcut | Optional keyboard shortcut that can be an int or string: (FL_CTRL+'a') or "^a". Default 0 if none.
  [in] | callback | Optional callback invoked when user clicks the item. Default 0 if none.
  [in] | userdata | Optional user data passed as an argument to the callback. Default 0 if none.
  [in] | flags | Optional flags that control the type of menu item; see below. Default is 0 for none.

Returns
  The index into the menu() array, where the entry was added.

Description
  If the menu array was directly set with menu(x), then copy() is done to make a private array.

  Since this method can change the internal menu array, any menu item pointers or indices the application may have cached can become stale, and should be recalculated/refreshed.

  A menu item's callback must not add() items to its parent menu during the callback.

Due to backwards compatibility and historical restrictions we recommend to use either

- static menu arrays that are not extended during runtime or
- dynamic, extendable menu item arrays that are entirely created by using add() or insert().

This ensures that all menu arrays and strings are copied to internal storage and released when required.

Note
  If you create menus from static Fl_Menu_Item arrays and add() or insert() more menu items later, then the menu array is copied to local storage but some local (static) strings may appear to "leak memory". This is a known issue and discouraged usage (see description above) but the impact on memory usage should typically be small.

Detailed Description of Parameters

label
  The menu item's label. This argument is required and must not be NULL.

  The characters "&", "/", "\", and "_" are treated as special characters in the label string. The "&" character specifies that the following character is an accelerator and will be underlined. The "" character is used to escape the next character in the string. Labels starting with the "_" character cause a divider to be placed after that menu item.

  A label of the form "File/Quit" will create the submenu "File" with a menu item called "Quit".

  The label string is copied to new memory and can be freed. The other arguments (including the shortcut) are copied into the menu item unchanged.

  If an item exists already with that name then it is replaced with this new one. Otherwise this new one is added to the end of the correct menu or submenu. The return value is the offset into the array that the new entry was placed at.

shortcut
  The keyboard shortcut for this menu item.

  This parameter is optional, and defaults to 0 to indicate no shortcut.

  The shortcut can either be a raw integer value (eg. FL_CTRL+'A') or a string (eg. "^c" or "^97").

  Raw integer shortcuts can be a combination of keyboard chars (eg. 'A') and optional keyboard modifiers (see Fl::event_state(), e.g. FL_SHIFT, etc). In addition, FL_COMMAND can be used to denote FL_META under Mac OS X and FL_CTRL under other platforms.

  String shortcuts can be specified in one of two ways:

       [#+^]<ascii_value>    e.g. "97", "^97", "+97", "#97"
       [#+^]<ascii_char>     e.g. "a", "^a", "+a", "#a"

  ..where <ascii_value> is a decimal value representing an ASCII character (eg. 97 is the ascii code for 'a'), and the optional prefixes enhance the value that follows. Multiple prefixes must appear in the order below.

       # - Alt
       + - Shift
       ^ - Control

  Internally, the text shortcuts are converted to integer values using fl_old_shortcut(const char*).

callback
  The callback to invoke when this menu item is selected.

  This parameter is optional, and defaults to 0 for no callback.

userdata
  The callback's 'user data' that is passed to the callback.

  This parameter is optional, and defaults to 0.

flags
  These are bit flags to define what kind of menu item this is.

  This parameter is optional, and defaults to 0 to define a 'regular' menu item.

  These flags can be 'OR'ed together:
  FL_MENU_INACTIVE // Deactivate menu item (gray out)
  FL_MENU_TOGGLE // Item is a checkbox toggle (shows checkbox for on/off state)
  FL_MENU_VALUE // The on/off state for checkbox/radio buttons (if set, state is 'on')
  FL_MENU_RADIO // Item is a radio button (one checkbox of many can be on)
  FL_MENU_INVISIBLE // Item will not show up (shortcut will work)
  FL_SUBMENU_POINTER // Indicates user_data() is a pointer to another menu array
  FL_SUBMENU // This item is a submenu to other items
  FL_MENU_DIVIDER // Creates divider line below this item. Also ends a group of radio buttons.

  All other bits in `'flags'` are reserved and must not be used.

If FL_SUBMENU is set in an item's flags, then actually two items are added:

- the first item is the menu item (submenu title), as expected, and
- the second item is the submenu terminating item with the label and all other members set to 0.

If you add submenus with the 'path' technique, then the corresponding submenu terminators (maybe more than one) are added as well.

Todo
  Raw integer shortcut needs examples. Dependent on responses to https://www.fltk.org/newsgroups.php?gfltk.coredev+v:10086 and results of STR#2344

## ◆ clear()

void Fl_Menu_::clear | ( |  | ) |

Same as menu(NULL), set the array pointer to null, indicating a zero-length menu.

Menus must not be cleared during a callback to the same menu.

## ◆ clear_submenu()

int Fl_Menu_::clear_submenu | ( | int | index | ) |

Clears the specified submenu pointed to by `index` of all menu items.

This method is useful for clearing a submenu so that it can be re-populated with new items. Example: a "File/Recent Files/..." submenu that shows the last few files that have been opened.

The specified `index` must point to a submenu.

The submenu is cleared with remove(). If the menu array was directly set with menu(x), then copy() is done to make a private array.

Warning
  Since this method can change the internal menu array, any menu item pointers or indices the application may have cached can become stale, and should be recalculated/refreshed.

Example:

int index = menubar->find_index("File/Recent"); // get index of "File/Recent" submenu
if ( index != -1 ) menubar->clear_submenu(index); // clear the submenu
menubar->add("File/Recent/Aaa");
menubar->add("File/Recent/Bbb");
[..]

Parameters

  index | The index of the submenu to be cleared

Returns
  0 on success, -1 if the index is out of range or not a submenu

See also
  remove(int)

## ◆ copy()

void Fl_Menu_::copy | ( | const Fl_Menu_Item * | m,
|  | void * | ud = 0 )

Sets the menu array pointer with a copy of m that will be automatically deleted.

If userdata `ud` is not NULL, then all user data pointers are changed in the menus as well. See void Fl_Menu_::menu(const Fl_Menu_Item* m).

## ◆ find_index() [1/3]

int Fl_Menu_::find_index | ( | const char * | pathname | ) | const

Find the menu item index for a given menu `pathname`, such as "Edit/Copy".

This method finds a menu item's index position for the given menu pathname, also traversing submenus, but not submenu pointers (FL_SUBMENU_POINTER).

To get the menu item pointer for a pathname, use find_item()

Parameters

  [in] | pathname | The path and name of the menu item to find

Returns
  The index of the matching item, or -1 if not found.

See also
  item_pathname()

## ◆ find_index() [2/3]

int Fl_Menu_::find_index | ( | const Fl_Menu_Item * | item | ) | const

Find the index into the menu array for a given `item`.

A way to convert a menu item pointer into an index.

Does not handle items that are in submenu pointers (FL_SUBMENU_POINTER).

-1 is returned if the item is not in this menu or is part of an FL_SUBMENU_POINTER submenu.

Current implementation is fast and not expensive.

// Convert an index-to-item
int index = 12;
const Fl_Menu_Item *item = mymenu->menu() + index;
// Convert an item-to-index
int index = mymenu->find_index(item);
if ( index == -1 ) { ..error.. }

Parameters

  [in] | item | The item to be found

Returns
  The index of the item, or -1 if not found.

See also
  menu()

## ◆ find_index() [3/3]

int Fl_Menu_::find_index | ( | Fl_Callback * | cb | ) | const

Find the index into the menu array for a given callback `cb`.

This method finds a menu item's index position, also traversing submenus, but not submenu pointers (FL_SUBMENU_POINTER). This is useful if an application uses internationalisation and a menu item can not be found using its label. This search is also much faster.

Parameters

  cb | Find the first item with this callback

Returns
  The index of the item with the specific callback, or -1 if not found

See also
  find_index(const char*)

## ◆ find_item() [1/2]

const Fl_Menu_Item * Fl_Menu_::find_item | ( | const char * | pathname | ) |

Find the menu item for a given menu `pathname`, such as "Edit/Copy".

This method finds a menu item in the menu array, also traversing submenus, but not submenu pointers (FL_SUBMENU_POINTER).

To get the menu item's index, use find_index(const char*)

Example:

Fl_Menu_Bar *menubar = new Fl_Menu_Bar(..);
menubar->add("File/&Open");
menubar->add("File/&Save");
menubar->add("Edit/&Copy");
// [..]
Fl_Menu_Item *item;
if ( ( item = (Fl_Menu_Item*)menubar->find_item("File/&Open") ) != NULL ) {
item->labelcolor(FL_RED);
}
if ( ( item = (Fl_Menu_Item*)menubar->find_item("Edit/&Copy") ) != NULL ) {
item->labelcolor(FL_GREEN);
}

Parameters

  pathname | The path and name of the menu item

Returns
  The item found, or NULL if not found

See also
  find_index(const char*), find_item(Fl_Callback*), item_pathname()

## ◆ find_item() [2/2]

const Fl_Menu_Item * Fl_Menu_::find_item | ( | Fl_Callback * | cb | ) |

Find the menu item for the given callback `cb`.

This method finds a menu item in a menu array, also traversing submenus, but not submenu pointers. This is useful if an application uses internationalisation and a menu item can not be found using its label. This search is also much faster.

Parameters

  [in] | cb | find the first item with this callback

Returns
  The item found, or NULL if not found

See also
  find_item(const char*)

## ◆ find_item_with_argument()

const Fl_Menu_Item * Fl_Menu_::find_item_with_argument | ( | long | v | ) |

Find the menu item for the given user argument `v`.

Parameters

  [in] | v | find the first item with this user argument

Returns
  The item found, or NULL if not found

See also
  find_item(const char*)

## ◆ find_item_with_user_data()

const Fl_Menu_Item * Fl_Menu_::find_item_with_user_data | ( | void * | v | ) |

Find the menu item for the given user data `v`.

Parameters

  [in] | v | find the first item with this user data

Returns
  The item found, or NULL if not found

See also
  find_item(const char*)

## ◆ global()

void Fl_Menu_::global | ( |  | ) |

Make the shortcuts for this menu work no matter what window has the focus when you type it.

This is done by using Fl::add_handler(). This Fl_Menu_ widget does not have to be visible (ie the window it is in can be hidden, or it does not have to be put in a window at all).

Currently there can be only one global()menu. Setting a new one will replace the old one. There is no way to remove the global() setting (so don't destroy the widget!)

## ◆ insert()

int Fl_Menu_::insert | ( | int | index,
|  | const char * | label,
|  | int | shortcut,
|  | Fl_Callback * | callback,
|  | void * | userdata = 0,
|  | int | flags = 0 )

Inserts a new menu item at the specified `index` position.

If `index` is -1, the menu item is appended; same behavior as add().

To properly insert a menu item, `label` must be the name of the item (eg. "Quit"), and not a 'menu pathname' (eg. "File/Quit"). If a menu pathname is specified, the value of `index` is ignored, the new item's position defined by the pathname.

For more details, see add(). Except for the `index` parameter, add() has more detailed information on parameters and behavior, and is functionally equivalent.

Parameters

  [in] | index | The menu array's index position where the new item is inserted. If -1, behavior is the same as add().
  [in] | label | The text label for the menu item. If the label is a menu pathname, `index` is ignored, and the pathname indicates the position of the new item.
  [in] | shortcut | Optional keyboard shortcut. Can be an int (FL_CTRL+'a') or a string ("^a"). Default is 0.
  [in] | callback | Optional callback invoked when user clicks the item. Default 0 if none.
  [in] | userdata | Optional user data passed as an argument to the callback. Default 0 if none.
  [in] | flags | Optional flags that control the type of menu item; see add() for more info. Default is 0 for none.

Returns
  The index into the menu() array, where the entry was added.

See also
  add()

## ◆ item_pathname()

int Fl_Menu_::item_pathname | ( | char * | name,
|  | int | namelen,
|  | const Fl_Menu_Item * | finditem = 0 ) const

Get the menu 'pathname' for the specified menuitem.

If finditem==NULL, mvalue() is used (the most recently picked menuitem).

Example:

Fl_Menu_Bar *menubar = 0;
void my_menu_callback(Fl_Widget*,void*) {
char name[80];
if ( menubar->item_pathname(name, sizeof(name)-1) == 0 ) { // recently picked item
if ( strcmp(name, "File/&Open") == 0 ) { .. } // open invoked
if ( strcmp(name, "File/&Save") == 0 ) { .. } // save invoked
if ( strcmp(name, "Edit/&Copy") == 0 ) { .. } // copy invoked
}
}
int main() {
[..]
menubar = new Fl_Menu_Bar(..);
menubar->add("File/&Open", 0, my_menu_callback);
menubar->add("File/&Save", 0, my_menu_callback);
menubar->add("Edit/&Copy", 0, my_menu_callback);
[..]
}

Returns
  - 0 : OK (name has menuitem's pathname)
  - -1 : item not found (name="")
  - -2 : 'name' not large enough (name="")

See also
  find_item()

## ◆ menu() [1/2]

const Fl_Menu_Item * Fl_Menu_::menu | ( |  | ) | const
| inline

Returns a pointer to the array of Fl_Menu_Items.

This will either be the value passed to menu(value) or the private copy or an internal (temporary) location (see note below).

Note
  Implementation details - may be changed in the future. All modifications of the menu array are done by copying the entire menu array to an internal storage for optimization of memory allocations, for instance when using add() or insert(). While this is done, menu() returns the pointer to this internal location. The entire menu will be copied back to private storage when needed, i.e. when another Fl_Menu_ is modified. You can force this reallocation after you're done with all menu modifications by calling Fl_Menu_::menu_end() to make sure menu() returns a permanent pointer to private storage (until the menu is modified again). Note also that some menu methods (e.g. Fl_Menu_Button::popup()) call menu_end() internally to ensure a consistent menu array while the menu is open.

See also
  size() – returns the size of the Fl_Menu_Item array.
  menu_end() – finish menu modifications (optional)

Example: How to walk the array:

for ( int t=0; t<menubar->size(); t++ ) { // walk array of items
const Fl_Menu_Item &item = menubar->menu()[t]; // get each item
fprintf(stderr, "item #%d -- label=%s, value=%s type=%s\n",
t,
item.label() ? item.label() : "(Null)", // menu terminators have NULL labels
(item.flags & FL_MENU_VALUE) ? "set" : "clear", // value of toggle or radio items
(item.flags & FL_SUBMENU) ? "Submenu" : "Item"); // see if item is a submenu or actual item
}

## ◆ menu() [2/2]

void Fl_Menu_::menu | ( | const Fl_Menu_Item * | m | ) |

Sets the menu array pointer directly.

If the old menu is private it is deleted. NULL is allowed and acts the same as a zero-length menu. If you try to modify the array (with add(), replace(), or remove()) a private copy is automatically done.

## ◆ menu_box() [1/2]

Fl_Boxtype Fl_Menu_::menu_box | ( |  | ) | const
| inline

Get the box type for the menu popup windows.

Returns
  the box type, or FL_NO_BOX if Fl_Menu_::box() is to be used instead

## ◆ menu_box() [2/2]

void Fl_Menu_::menu_box | ( | Fl_Boxtype | b | ) |
| inline

Set the box type for the menu popup windows.

If menu_box set to FL_NO_BOX, the menu window will use Fl_Menu_::box() instead.

Parameters

  [in] | b | new box type or FL_NO_BOX

## ◆ menu_end()

const Fl_Menu_Item * Fl_Menu_::menu_end | ( |  | ) |

Finishes menu modifications and returns menu().

Call menu_end() after using add(), insert(), remove(), or any other methods that may change the menu array if you want to access the menu array anytime later with menu(). This should be called only once after the last menu modification for performance reasons.

Does nothing if the menu array is already in a private location.

Some methods like Fl_Menu_Button::popup() call this method before their menu is opened.

Note
  After menu changes like add(), insert(), etc. menu() would return a pointer to a temporary internal menu array that may be relocated at unexpected times. This is due to performance considerations and may be changed w/o further notice.

Since
  1.4.0

Returns
  New Fl_Menu_Item array pointer.

See also
  Fl_Menu_::menu()

## ◆ mode() [1/2]

int Fl_Menu_::mode | ( | int | i | ) | const
| inline

Get the flags of item i.

For a list of the flags, see Fl_Menu_Item.

## ◆ mode() [2/2]

void Fl_Menu_::mode | ( | int | i,
|  | int | fl )
| inline

Set the flags of item i.

For a list of the flags, see Fl_Menu_Item.

## ◆ picked()

const Fl_Menu_Item * Fl_Menu_::picked | ( | const Fl_Menu_Item * | v | ) |

When user picks a menu item, call this.

It will do the callback.

Unfortunately this also casts away const for the checkboxes, but this was necessary so non-checkbox menus can really be declared 'const'.

Parameters

  [in] | v | The menu item that was picked by the user.

Returns
  The same Fl_Menu_Item* that was set (`v`).

## ◆ prev_mvalue()

const Fl_Menu_Item * Fl_Menu_::prev_mvalue | ( |  | ) | const
| inline

Return a pointer to the menu item that was picked before the current one was picked.

This call gives developers additional details how a user changed a choice in the Fl_Choice widget.

## ◆ remove()

void Fl_Menu_::remove | ( | int | i | ) |

Deletes item `i` from the menu.

If the menu array was directly set with menu(x) then copy() is done to make a private array.

No items must be removed from a menu during a callback to the same menu.

Parameters

  i | index into menu array

## ◆ replace()

void Fl_Menu_::replace | ( | int | i,
|  | const char * | str )

Changes the text of item `i`.

This is the only way to get slash into an add()'ed menu item. If the menu array was directly set with menu(x) then copy() is done to make a private array.

Parameters

  i | index into menu array
  str | new label for menu item at index i

## ◆ size()

int Fl_Menu_::size | ( |  | ) | const

This returns the number of Fl_Menu_Item structures that make up the menu, correctly counting submenus.

This includes the "terminator" item at the end. To copy a menu array you need to copy size()*sizeof(Fl_Menu_Item) bytes. If the menu is NULL this returns zero (an empty menu will return 1).

## ◆ test_shortcut()

const Fl_Menu_Item * Fl_Menu_::test_shortcut | ( |  | ) |
| inline

Returns the menu item with the entered shortcut (key value).

This searches the complete menu() for a shortcut that matches the entered key value. It must be called for a FL_KEYBOARD or FL_SHORTCUT event.

If a match is found, the menu's callback will be called.

Returns
  matched Fl_Menu_Item or NULL.

## ◆ value() [1/3]

int Fl_Menu_::value | ( |  | ) | const

Return the index into the menu() of the last item chosen by the user.

The value of the menu is the index into the menu() of the last item chosen by the user or -1.

It is `-1` initially (if no item has been chosen) or if the chosen menu item is part of a submenu addressed by an FL_SUBMENU_POINTER.

Note
  All menu items are located in a contiguous array of Fl_Menu_Item's unless an item has the FL_SUBMENU_POINTER flag which redirects the submenu to an independent submenu array. This submenu array is not counted in the size() of the menu, and menu items in this submenu can't return a valid index into the main menu. Therefore menu items that are located in such a submenu return -1 when value() is called. This may be changed in a future version.

You can use mvalue() instead to retrieve the last picked menu item directly.

Returns
  Index of the last chosen menu item or -1 (see description).

See also
  const Fl_Menu_Item *mvalue()

## ◆ value() [2/3]

int Fl_Menu_::value | ( | const Fl_Menu_Item * | m | ) |

Set the value of a menu to the menu item `m`.

The value of the menu is the index into the menu() of the last item chosen by the user or -1.

It is `-1` initially (if no item has been chosen) or if the chosen menu item is part of a submenu addressed by an FL_SUBMENU_POINTER.

Note
  All menu items are located in a contiguous array of Fl_Menu_Item's unless an item has the FL_SUBMENU_POINTER flag which redirects the submenu to an independent submenu array. This submenu array is not counted in the size() of the menu, and menu items in this submenu can't return a valid index into the main menu. Therefore menu items that are located in such a submenu return -1 when value() is called. This may be changed in a future version.

The menu item can be any menu item, even one in a detached submenu (see note about FL_SUBMENU_POINTER above).

Parameters

  [in] | m | Pointer to any menu item.

Returns
  Whether the new value is different than the old one.

Return values

  0 | The value didn't change.
  1 | The value was changed.

See also
  int value(int)
  int value()
  const Fl_Menu_Item *mvalue()

## ◆ value() [3/3]

int Fl_Menu_::value | ( | int | i | ) |
| inline

Set the value of the menu to index `i`.

The value of the menu is the index into the menu() of the last item chosen by the user or -1.

It is `-1` initially (if no item has been chosen) or if the chosen menu item is part of a submenu addressed by an FL_SUBMENU_POINTER.

Note
  All menu items are located in a contiguous array of Fl_Menu_Item's unless an item has the FL_SUBMENU_POINTER flag which redirects the submenu to an independent submenu array. This submenu array is not counted in the size() of the menu, and menu items in this submenu can't return a valid index into the main menu. Therefore menu items that are located in such a submenu return -1 when value() is called. This may be changed in a future version.

You can set the value as an integer or with a pointer to a menu item. The integer value is restricted to the main menu array (0..size()-1) whereas the menu item can be any menu item, even one in a detached submenu (see note about FL_SUBMENU_POINTER above).

Parameters

  [in] | i | Index of the menu item in the main menu array. Values outside 0..size()-1 are ignored (return 0).

Returns
  Whether the new value is different than the old one.

Return values

  0 | The value didn't change.
  1 | The value was changed.

See also
  int value(const Fl_Menu_Item*)
  int value()
  const Fl_Menu_Item *mvalue()

The documentation for this class was generated from the following files:

- Fl_Menu_.H
- Fl_Menu_.cxx
- Fl_Menu_add.cxx
- Fl_Menu_global.cxx